#property copyright "Viatcheslav Suvorov"
#property show_inputs
extern int smoothing=5;
//**************************************************************
datetime t0,t1;
int profile[];
bool NeedInit=true; 
int init()
{
   t0=TimeOnDropped();
   int i0=iBarShift(Symbol(),Period(),t0); 
   int i1=i0+20;
   t1=Time[i1];
  
     
   ObjectCreate("leftMP",0,0,t1,0);
   ObjectSet("leftMP",OBJPROP_COLOR,Yellow);
   
   ObjectCreate("rightMP",0,0,t0,0);
   ObjectSet("rightMP",OBJPROP_COLOR,Yellow);   
   
} 
//**************************************************************
int start()
{
  NeedInit=true;
  while(IsStopped()==false)
  { 
    if (ObjectFind("rightMP") != -1) datetime cur_t0=ObjectGet("rightMP",OBJPROP_TIME1); else {
      cur_t0=t0;
      Print("  . ");
    }  
    if (ObjectFind("leftMP") != -1) datetime cur_t1=ObjectGet("leftMP",OBJPROP_TIME1); else {
      cur_t1=t1;
      Print("  . ");
    }  
//    if (ObjectFind("rec"+0) == -1) NeedInit=true;
    //Sleep(1000);
    if ((cur_t0!=t0) || (cur_t1!=t1) || NeedInit){   
      ObjectsDeleteAll(0,OBJ_RECTANGLE);
      NeedInit=false;
      t0=cur_t0;
      t1=cur_t1;
      int i0=iBarShift(NULL,0,t0); 
      int i1=iBarShift(NULL,0,t1); 
      if (i0>i1){
        int il=i0;
        int ir=i1;
      } else {
        il=i1;
        ir=i0;        
      }//if else      
      double ProfMin=Low[Lowest(NULL,0,MODE_LOW,il-ir,ir)];
      double ProfMax=High[Highest(NULL,0,MODE_HIGH,il-ir,ir)];
      int TPO=(ProfMax-ProfMin)/Point;
      ArrayResize(profile,TPO);
      ArrayInitialize(profile,0);
      for (int i=il;i>=ir;i--){
        for (double j=Low[i];j<=High[i];j+=Point){
          int index=(j-ProfMin)/Point-1;
          profile[index]++;
        }//for
      }//for
      int Summ=0;
      if (smoothing>0){        
/*        for (i=MathRound(TPO/2);i<=TPO-1;i++){          
          profile[i]=(2*profile[i]/(smoothing+1))+((smoothing-1)*profile[i-1]/(smoothing+1));          
        }//for
        for (i=MathRound(TPO/2);i>=0;i--){          
          profile[i]=(2*profile[i]/(smoothing+1))+((smoothing-1)*profile[i+1]/(smoothing+1));          
        }//for        */
        for (i=0;i<=TPO-1;i++){          
          profile[i]=(2*profile[i]/(smoothing+1))+((smoothing-1)*profile[i-1]/(smoothing+1));          
        }//for
        
      }//if        
      ObjectsDeleteAll(0,OBJ_RECTANGLE);
      for (i=0;i<=TPO-1;i++){
       if ((ObjectFind("rec"+i) == -1) && (profile[i]>0)) {
           ObjectCreate("rec"+i, OBJ_RECTANGLE, 0, Time[il],ProfMin+i*Point,Time[il-profile[i]],ProfMin+(i+1)*Point);
           ObjectSet("rec"+i, OBJPROP_COLOR, Blue);
           ObjectSet("rec"+i, OBJPROP_BACK, false);
       }//if
      }//for
      ObjectsRedraw( );
    }//if
  }//while 
   return(0);
}
//***************************************************************
void deinit()
{
  ObjectDelete("rightMP");
  ObjectDelete("leftMP");  
  ObjectsDeleteAll(0,OBJ_RECTANGLE);
}
//***************************************************************



